using PkmnLib.Plugin.Gen7.Scripts.Pokemon;

namespace PkmnLib.Plugin.Gen7.Scripts.Moves;

[Script(ScriptCategory.Move, "dig")]
public class Dig : Script, IScriptPreventMove, IScriptOnBeforeMove
{
    /// <inheritdoc />
    public void PreventMove(IExecutingMove move, ref bool prevent)
    {
        if (move.User.Volatile.Contains<DigEffect>())
            return;

        move.User.Volatile.Add(new DigEffect(move.User));
        move.MoveChoice.SetAdditionalData("dig_charge", true);
        move.User.BattleData?.Battle.EventHook.Invoke(new DialogEvent("dig_charge", new Dictionary<string, object>
        {
            { "user", move.User },
        }));
        prevent = true;
    }

    /// <inheritdoc />
    public void OnBeforeMove(IExecutingMove move)
    {
        move.User.Volatile.Remove(ScriptUtils.ResolveName<DigEffect>());
    }
}